<?php
/*
  Plugin Name: GuruFocus Guru Links
  Plugin URI: http://www.gurufocus.com/
  Version: 1.0.0
  Author: GuruFocus
  Author URI: http://www.gurufocus.com/
  Description: If you mention people such as Warren Buffett, George Soros, Carl Icachn, an affiliate link will be added to the portfolio pages of these investors at <a href="http://www.gurufocus.com/">GuruFocus.com</a>.
 */

function gurufocus_guru_links_process_content($content) {
    $GuruList = array('Warren Buffett', 'George Soros', 'Carl Icahn', 'David Einhorn', 'Joel Greenblatt', 'Bill Ackman', 'Bill Gates', 'David Tepper', 'Edward Lampert', 'Howard Marks', 'Mohnish Pabrai', 'Ray Dalio', 'Boone Pickens');

    foreach ($GuruList as $GuruName) {
        $GLOBALS['replace_count']=0;
        $content =
                preg_replace_callback('/' . $GuruName . '(?![^<]*<\/a>)/i', 'guruname_callback', $content
        );
    }

    return $content;
}

function guruname_callback($matchs) {

    $GuruName = $matchs[0];

    $user_id = get_option("gurufocus_user_id");
    if ($user_id) {
        $affiliate = "?affid=" . $user_id;
    }

    $content = '<a href="http://www.gurufocus.com/guru/' . urlencode($GuruName) . $affiliate . '" class="guru" target="_blank">' . $GuruName . '</a>';

    global $replace_count;
    $single = get_option("gurufocus_guru_link_single");
    if ($single) {
        $GLOBALS['replace_count']++;
        if ($GLOBALS['replace_count'] > 1)
            return $GuruName;
        else
            return $content;
    }else {
        return $content;
    }
}

add_filter('the_content', 'gurufocus_guru_links_process_content');
add_filter('the_content_limit', 'gurufocus_guru_links_process_content');
add_filter('the_excerpt', 'gurufocus_guru_links_process_content');
add_filter('the_content_rss', 'gurufocus_guru_links_process_content');
add_filter('the_excerpt_rss', 'gurufocus_guru_links_process_content');


/** Step 2 (from text above). */
add_action('admin_menu', 'gurufocus_guru_links_plugin_menu');

/** Step 1. */
function gurufocus_guru_links_plugin_menu() {
    add_submenu_page('plugins.php', __('GuruFocus Guru Links Configuration'), __('GuruFocus Guru Links'), 'manage_options', 'gurufocus_guru_links', 'gurufocus_guru_links_conf');
}

/** Step 3. */
function gurufocus_guru_links_conf() {
    if (!current_user_can('manage_options')) {
        wp_die(__('You do not have sufficient permissions to access this page.'));
    }

    if (isset($_POST['submit'])) {
        $user_id = $_POST['user_id'];
        update_option("gurufocus_user_id", $user_id);
        if ($_POST['single']) {
            update_option("gurufocus_guru_link_single", true);
        } else {
            update_option("gurufocus_guru_link_single", false);
        }
    }

    if (!empty($_POST['submit'])) {
        ?>
        <div id="message" class="updated fade"><p><strong><?php _e('Options saved.') ?></strong></p></div>
        <?php
    }

    echo '<div class="wrap">';
    ?>
    <h4><?php _e('GuruFocus Guru Links:'); ?></h4>
    <h4>Input your Affiliate ID on GuruFocus.com</h4>
    <form action="" method="post" id="gurufocus-ticker-links-conf">
        <h3><label for="user_id">Affiliate ID</label></h3>
        <p><input name="user_id" id="user_id" value="<?php echo get_option("gurufocus_user_id"); ?>" />
            (<a href="https://www.gurufocus.com/user/me?tab=account&subtab=account-aff" target="_blank">Get this?</a>)
        </p>
        <h3><label for="single">
                <input type="checkbox" name="single" id="single" <?php if (get_option('gurufocus_guru_link_single')) {
        echo 'checked';
    } ?> />
                Only add link to the first time appears Guru's name</label></h3>

        <p class="submit"><input type="submit" name="submit" value="<?php _e('Update options &raquo;'); ?>" /></p>
    </form>
    <?php
    echo '</div>';
}
?>